/* This programs eats strings with network data from stdin in format
*  x.x.x.x - y.y.y.y or x.x.x.x/bits
*  summarize it and produce output in format
*  suitble for netams target file and some other programms
*  
*  (c) 2005 Yuriy N. Shkandybin
*  $Id: subnet-sum.c,v 1.2 2005-11-07 20:55:01 anton Exp $
*
* build this with:
* g++ -o subnet-sum subnet-sum.c 
* 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

typedef struct node {
	u_char full;
	struct node *up;
	struct node *left;
	struct node *right;
} NODE;

NODE *root;

#define ANY	0xFFFFFFFF

u_char addr2tree(unsigned *addr, unsigned len);
void freetree(NODE *ptr);
void showtree(NODE *ptr, unsigned addr, u_char depth);

int  main () {
	FILE *f;
	char buf[64];
	char *ptr;
	struct in_addr addr1, addr2, tmp;
	unsigned a1,a2, addr;
	u_char mask;

	f=stdin;
//	f=fopen("1","r");

	//initialize root for bi-tree
	root=(NODE*)malloc(sizeof(NODE));
	root->full=0;
	root->up=root->left=root->right=NULL;

	while(!feof(f)) {
		fgets(buf, 63, f);
		if(feof(f)) break;

		if(*buf=='#') continue;
	
		ptr=strchr(buf, '-');
		if(ptr) {
			*ptr=0;
			ptr++;
			inet_aton(buf,&addr1); a1=ntohl(addr1.s_addr);
			inet_aton(ptr,&addr2); a2=ntohl(addr2.s_addr);
		} else if((ptr=strchr(buf, '/'))) {
			*ptr=0;
			ptr++;
			inet_aton(buf,&addr1); a1=ntohl(addr1.s_addr);
			mask=atoi(ptr);
			a1=(a1>>(32-mask))<<(32-mask);
			a2=a1+(1<<(32-mask))-1;
		}	

		for(addr=a1; addr <=a2; addr++) {
			tmp.s_addr=htonl(addr);
			mask = addr2tree(&addr,a2-addr);
//			printf("add %s/%u\n", inet_ntoa(tmp),mask);
//			showtree(root, 0, 0);
//			printf("----------\n");
		}
	}
//	printf("----------------------\n");
	showtree(root, 0, 0);
	freetree(root);
	return 0;
}

u_char addr2tree(unsigned *addr, unsigned len){
	NODE *ptr, *tmp;
	unsigned i,num;

	ptr=root;
	
	for (i=0;i<32;i++) {
		if(ptr->full) {
			*addr=(*addr|(ANY>>i));
			return i;
		}
		
		num = 1<<(31-i);
		if((*addr)&num) {
			if(!ptr->right) {
				tmp=(NODE*)malloc(sizeof(NODE));
				ptr->right=tmp;
				tmp->up=ptr;
				tmp->left=tmp->right=NULL;
  	                	tmp->full=0;
  	                }
			ptr=ptr->right;
		} else {
			if(!ptr->left) {
				tmp=(NODE*)malloc(sizeof(NODE));
				ptr->left=tmp;
				tmp->up=ptr;
				tmp->left=tmp->right=NULL;
				tmp->full=0;
			}
			ptr=ptr->left;
		}
	}
	
	num=0;
	for(i=31;i>=0;i--) {
		if((ANY>>i) > len) break;
		tmp=ptr->up;
		if(tmp->right == ptr) break;
		ptr=tmp;
		num=(ANY>>i);
	}
	(*addr)+=num;
	ptr->full=1;

	if(ptr->left) { 
		freetree(ptr->left);
		ptr->left=NULL;
	}
	if(ptr->right) {
		freetree(ptr->right);
		ptr->right=NULL;
	}
	return i+1;
}

void freetree(NODE *ptr) {
	if(ptr->left) freetree(ptr->left);
	if(ptr->right) freetree(ptr->right);
	free(ptr);
}

void showtree(NODE *ptr, unsigned addr, u_char depth) {
	struct in_addr ia;
	if(ptr->full) {
		ia.s_addr=ntohl(addr<<(32-depth));
		printf("%s/%u\n", inet_ntoa(ia), depth);
	} else {
		if(ptr->left)  showtree(ptr->left,addr<<1,depth+1);
		if(ptr->right) showtree(ptr->right,(addr<<1)+1,depth+1);
	}
}
